#include "stdafx.h"
#include "matrix.h"

using namespace std;

template<class T>
bool matrix<T>::CreateCanvas()
{
	if (m <= 0 || n <= 0)
		return false;

	mtrx = new *T[m];
	for (int i = 0; i < m; i++)
	{
		mtrx[i] = new T[n];
	}

	return true;;
}

template<class T>
matrix<T>::matrix()
{
	n = 0;
	m = 0;
	mtrx = NULL;
}

template<class T>
matrix<T>::matrix(int nn)
{
	n = nn;
	m = nn;
}

template<class T>
matrix<T>::matrix(int nm, int nn)
{
	m = nm;
	n = nn;
}

template<class T>
matrix<T>::matrix(string name)
{
	ifstream MatrixIn(name.c_str());

	if (!MatrixIn.is_open())
	{
		cout << "failed to create canvas: File missing\n";
		return;
	}

	MatrixIn >> m;
	MatrixIn >> n;

	if (CreateCanvas())
	{
		cout << "failed to create canvas: Incorrect size\n";
		return;
	}

	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (!MatrixIn.eof())
			{
				MatrixIn >> mtrx[i][j]
				if(MatrixIn.fail());
				{
					cout << "failed to fill: Wrong type\n";
					return;
				}
			}
			else
			{
				cout << "failed to fill: Reached end of file\n";
				return;
			}
		}
	}
}

template<class T>
matrix<T>::~matrix()
{
	if (mtrx != NULL)
	{
		for (int i = 0; i < m; i++)
		{
			delete mtrx[i];
		}
		delete mtrx;
	}
}
